#include <stdio.h>
#include <mintbind.h>
#include <file.h>

# define MODULE_PLAY	('A'<<8|0)
# define MODULE_STOP	('A'<<8|1)
# define MODULE_FLUSH	('A'<<8|2)
# define MODULE_FX	('A'<<8|3)
#  define SURROUND	1
#  define INTERPOLATION	2
# define MODULE_SRDELAY	('A'<<8|4)
# define MODULE_RESET	('A'<<8|5)

# define DEV	"u:\\dev\\modplay"

int
main(int argc, char *argv[])
{
	short fd;
	char *buf;
	long r;
	XATTR atr, *a;

	if (argc == 1) {
		fd = Fopen(DEV, O_WRONLY);
		r = Fcntl(fd, 0L, MODULE_FLUSH);
		Fclose(fd);
		return r;
	}

	a = &atr;
	r = Fxattr(0, argv[1], a);
 
	if (r < 0) return r;

	if (!a->size) return 0;

	buf = (char *)Mxalloc(a->size, 3);
	fd = Fopen(argv[1], 0);
	(void)Fread(fd, a->size, buf);
	Fclose(fd);

	fd = Fopen(DEV, O_WRONLY);

	if (fd < 0) return fd;

	r = Foutstat(fd);

	if (r < 0) return r;

	if (!r || (a->size > r)) return 0;

	r = Fwrite(fd, a->size, buf);

	if (r == 0) return 0;

	if (r < 0) return r;

	Mfree(buf);

	(void)Fcntl(fd, INTERPOLATION|SURROUND, MODULE_FX);

	r = Fcntl(fd, 0L, MODULE_PLAY);

	if (r < 0) {
		Fcntl(fd, 0L, MODULE_FLUSH);
		Fcntl(fd, 0L, MODULE_RESET);
	}

	Fclose(fd);

	return 0;
}
